diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/wifi/model/mac-low.cc ns-3.32/src/wifi/model/mac-low.cc
--- ns-3.31/src/wifi/model/mac-low.cc	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/wifi/model/mac-low.cc	2020-10-06 15:35:43.000000000 -0700
@@ -328,24 +328,6 @@
 }
 
 void
-MacLow::SetAckTimeout (Time ackTimeout)
-{
-  m_ackTimeout = ackTimeout;
-}
-
-void
-MacLow::SetBasicBlockAckTimeout (Time blockAckTimeout)
-{
-  m_basicBlockAckTimeout = blockAckTimeout;
-}
-
-void
-MacLow::SetCompressedBlockAckTimeout (Time blockAckTimeout)
-{
-  m_compressedBlockAckTimeout = blockAckTimeout;
-}
-
-void
 MacLow::SetCtsToSelfSupported (bool enable)
 {
   m_ctsToSelfSupported = enable;
@@ -358,30 +340,6 @@
 }
 
 void
-MacLow::SetSifs (Time sifs)
-{
-  m_sifs = sifs;
-}
-
-void
-MacLow::SetSlotTime (Time slotTime)
-{
-  m_slotTime = slotTime;
-}
-
-void
-MacLow::SetPifs (Time pifs)
-{
-  m_pifs = pifs;
-}
-
-void
-MacLow::SetRifs (Time rifs)
-{
-  m_rifs = rifs;
-}
-
-void
 MacLow::SetBeaconInterval (Time interval)
 {
   m_beaconInterval = interval;
@@ -412,45 +370,21 @@
 }
 
 Time
-MacLow::GetAckTimeout (void) const
-{
-  return m_ackTimeout;
-}
-
-Time
-MacLow::GetBasicBlockAckTimeout (void) const
-{
-  return m_basicBlockAckTimeout;
-}
-
-Time
-MacLow::GetCompressedBlockAckTimeout (void) const
-{
-  return m_compressedBlockAckTimeout;
-}
-
-Time
 MacLow::GetSifs (void) const
 {
-  return m_sifs;
-}
-
-Time
-MacLow::GetRifs (void) const
-{
-  return m_rifs;
+  return m_phy->GetSifs ();
 }
 
 Time
 MacLow::GetSlotTime (void) const
 {
-  return m_slotTime;
+  return m_phy->GetSlot ();
 }
 
 Time
 MacLow::GetPifs (void) const
 {
-  return m_pifs;
+  return m_phy->GetPifs ();
 }
 
 Mac48Address
@@ -532,12 +466,12 @@
   /* The packet received by this function can be any of the following:
    * (a) a management frame dequeued from the Txop
    * (b) a non-QoS data frame dequeued from the Txop
-   * (c) a non-broadcast QoS Data frame peeked or dequeued from a QosTxop
-   * (d) a broadcast QoS data or DELBA Request frame dequeued from a QosTxop
+   * (c) a non-group addressed QoS Data frame peeked or dequeued from a QosTxop
+   * (d) a group addressed QoS data or DELBA Request frame dequeued from a QosTxop
    * (e) a BlockAckReq or ADDBA Request frame
    * (f) a fragment of non-QoS/QoS Data frame dequeued from the Txop/QosTxop
    */
-  if (hdr.IsQosData () && !hdr.GetAddr1 ().IsBroadcast ()
+  if (hdr.IsQosData () && !hdr.GetAddr1 ().IsGroup ()
       && !hdr.IsMoreFragments () && hdr.GetFragmentNumber () == 0)
     {
       // We get here if the received packet is a non-broadcast QoS data frame
@@ -698,7 +632,7 @@
   // Get the maximum PPDU Duration based on the preamble type
   Time maxPpduDuration = GetPpduMaxTime (txVector.GetPreambleType ());
 
-  Time txTime = m_phy->CalculateTxDuration (ppduPayloadSize, txVector, m_phy->GetFrequency ());
+  Time txTime = m_phy->CalculateTxDuration (ppduPayloadSize, txVector, m_phy->GetPhyBand ());
 
   if ((ppduDurationLimit.IsStrictlyPositive () && txTime > ppduDurationLimit)
       || (maxPpduDuration.IsStrictlyPositive () && txTime > maxPpduDuration))
@@ -918,26 +852,12 @@
 
       if (m_txParams.HasNextPacket ())
         {
-          if (m_stationManager->GetRifsPermitted ())
-            {
-              m_waitIfsEvent = Simulator::Schedule (GetRifs (), &MacLow::WaitIfsAfterEndTxFragment, this);
-            }
-          else
-            {
-              m_waitIfsEvent = Simulator::Schedule (GetSifs (), &MacLow::WaitIfsAfterEndTxFragment, this);
-            }
+          m_waitIfsEvent = Simulator::Schedule (GetSifs (), &MacLow::WaitIfsAfterEndTxFragment, this);
         }
       else if (m_currentPacket->GetHeader (0).IsQosData () && m_currentTxop->IsQosTxop () &&
                m_currentTxop->GetTxopLimit ().IsStrictlyPositive () && m_currentTxop->GetTxopRemaining () > GetSifs ())
         {
-          if (m_stationManager->GetRifsPermitted ())
-            {
-              m_waitIfsEvent = Simulator::Schedule (GetRifs (), &MacLow::WaitIfsAfterEndTxPacket, this);
-            }
-          else
-            {
-              m_waitIfsEvent = Simulator::Schedule (GetSifs (), &MacLow::WaitIfsAfterEndTxPacket, this);
-            }
+          m_waitIfsEvent = Simulator::Schedule (GetSifs (), &MacLow::WaitIfsAfterEndTxPacket, this);
         }
       else if (m_currentTxop->IsQosTxop ())
         {
@@ -960,14 +880,7 @@
       if (m_currentTxop->IsQosTxop () && m_currentTxop->GetTxopLimit ().IsStrictlyPositive ()
           && m_currentTxop->GetTxopRemaining () > GetSifs ())
         {
-          if (m_stationManager->GetRifsPermitted ())
-            {
-              m_waitIfsEvent = Simulator::Schedule (GetRifs (), &MacLow::WaitIfsAfterEndTxPacket, this);
-            }
-          else
-            {
-              m_waitIfsEvent = Simulator::Schedule (GetSifs (), &MacLow::WaitIfsAfterEndTxPacket, this);
-            }
+          m_waitIfsEvent = Simulator::Schedule (GetSifs (), &MacLow::WaitIfsAfterEndTxPacket, this);
         }
       else if (m_currentTxop->IsQosTxop ())
         {
@@ -1238,7 +1151,7 @@
 MacLow::GetAckDuration (WifiTxVector ackTxVector) const
 {
   NS_ASSERT (ackTxVector.GetMode ().GetModulationClass () != WIFI_MOD_CLASS_HT); //Ack should always use non-HT PPDU (HT PPDU cases not supported yet)
-  return m_phy->CalculateTxDuration (GetAckSize (), ackTxVector, m_phy->GetFrequency ());
+  return m_phy->CalculateTxDuration (GetAckSize (), ackTxVector, m_phy->GetPhyBand ());
 }
 
 Time
@@ -1248,13 +1161,13 @@
    * For immediate Basic BlockAck we should transmit the frame with the same WifiMode
    * as the BlockAckReq.
    */
-  return m_phy->CalculateTxDuration (GetBlockAckSize (type), blockAckReqTxVector, m_phy->GetFrequency ());
+  return m_phy->CalculateTxDuration (GetBlockAckSize (type), blockAckReqTxVector, m_phy->GetPhyBand ());
 }
 
 Time
 MacLow::GetBlockAckRequestDuration (WifiTxVector blockAckReqTxVector, BlockAckType type) const
 {
-  return m_phy->CalculateTxDuration (GetBlockAckRequestSize (type), blockAckReqTxVector, m_phy->GetFrequency ());
+  return m_phy->CalculateTxDuration (GetBlockAckRequestSize (type), blockAckReqTxVector, m_phy->GetPhyBand ());
 }
 
 Time
@@ -1268,7 +1181,7 @@
 MacLow::GetCtsDuration (WifiTxVector ctsTxVector) const
 {
   NS_ASSERT (ctsTxVector.GetMode ().GetModulationClass () != WIFI_MOD_CLASS_HT); //CTS should always use non-HT PPDU (HT PPDU cases not supported yet)
-  return m_phy->CalculateTxDuration (GetCtsSize (), ctsTxVector, m_phy->GetFrequency ());
+  return m_phy->CalculateTxDuration (GetCtsSize (), ctsTxVector, m_phy->GetPhyBand ());
 }
 
 WifiTxVector
@@ -1463,7 +1376,7 @@
   v.SetPreambleType (GetPreambleForTransmission (ctsMode.GetModulationClass (), m_stationManager->GetShortPreambleEnabled (), m_stationManager->UseGreenfieldForDestination (to)));
   v.SetTxPowerLevel (m_stationManager->GetDefaultTxPowerLevel ());
   v.SetChannelWidth (GetChannelWidthForTransmission (ctsMode, m_phy->GetChannelWidth ()));
-   uint16_t ctsTxGuardInterval = ConvertGuardIntervalToNanoSeconds (ctsMode, m_phy->GetShortGuardInterval (), m_phy->GetGuardInterval ());
+   uint16_t ctsTxGuardInterval = ConvertGuardIntervalToNanoSeconds (ctsMode, DynamicCast<WifiNetDevice> (m_phy->GetDevice ()));
   v.SetGuardInterval (ctsTxGuardInterval);
   v.SetNss (1);
   return v;
@@ -1479,7 +1392,7 @@
   v.SetPreambleType (GetPreambleForTransmission (ackMode.GetModulationClass (), m_stationManager->GetShortPreambleEnabled (), m_stationManager->UseGreenfieldForDestination (to)));
   v.SetTxPowerLevel (m_stationManager->GetDefaultTxPowerLevel ());
   v.SetChannelWidth (GetChannelWidthForTransmission (ackMode, m_phy->GetChannelWidth ()));
-   uint16_t ackTxGuardInterval = ConvertGuardIntervalToNanoSeconds (ackMode, m_phy->GetShortGuardInterval (), m_phy->GetGuardInterval ());
+   uint16_t ackTxGuardInterval = ConvertGuardIntervalToNanoSeconds (ackMode, DynamicCast<WifiNetDevice> (m_phy->GetDevice ()));
   v.SetGuardInterval (ackTxGuardInterval);
   v.SetNss (1);
   return v;
@@ -1495,7 +1408,7 @@
   v.SetPreambleType (GetPreambleForTransmission (blockAckMode.GetModulationClass (), m_stationManager->GetShortPreambleEnabled (), m_stationManager->UseGreenfieldForDestination (to)));
   v.SetTxPowerLevel (m_stationManager->GetDefaultTxPowerLevel ());
   v.SetChannelWidth (GetChannelWidthForTransmission (blockAckMode, m_phy->GetChannelWidth ()));
-uint16_t blockAckTxGuardInterval = ConvertGuardIntervalToNanoSeconds (blockAckMode, m_phy->GetShortGuardInterval (), m_phy->GetGuardInterval ());
+uint16_t blockAckTxGuardInterval = ConvertGuardIntervalToNanoSeconds (blockAckMode, DynamicCast<WifiNetDevice> (m_phy->GetDevice ()));
   v.SetGuardInterval (blockAckTxGuardInterval);
   v.SetNss (1);
   return v;
@@ -1531,7 +1444,7 @@
     {
       dataSize = GetSize (packet, hdr, m_currentPacket && m_currentPacket->IsAggregate ());
     }
-  txTime += m_phy->CalculateTxDuration (dataSize, GetDataTxVector (item), m_phy->GetFrequency ());
+  txTime += m_phy->CalculateTxDuration (dataSize, GetDataTxVector (item), m_phy->GetPhyBand ());
   return txTime;
 }
 
@@ -1543,7 +1456,7 @@
   if (params.MustSendRts ())
     {
       WifiTxVector rtsTxVector = GetRtsTxVector (item);
-      txTime += m_phy->CalculateTxDuration (GetRtsSize (), rtsTxVector, m_phy->GetFrequency ());
+      txTime += m_phy->CalculateTxDuration (GetRtsSize (), rtsTxVector, m_phy->GetPhyBand ());
       txTime += GetCtsDuration (item->GetHeader ().GetAddr1 (), rtsTxVector);
       txTime += Time (GetSifs () * 2);
     }
@@ -1562,7 +1475,7 @@
     {
       WifiTxVector dataTxVector = GetDataTxVector (Create<const WifiMacQueueItem> (packet, *hdr));
       txTime += GetSifs ();
-      txTime += m_phy->CalculateTxDuration (params.GetNextPacketSize (), dataTxVector, m_phy->GetFrequency ());
+      txTime += m_phy->CalculateTxDuration (params.GetNextPacketSize (), dataTxVector, m_phy->GetPhyBand ());
     }
   return txTime;
 }
@@ -1602,7 +1515,7 @@
           cts.SetType (WIFI_MAC_CTL_CTS);
           WifiTxVector txVector = GetRtsTxVector (Create<const WifiMacQueueItem> (packet, hdr));
           Time navCounterResetCtsMissedDelay =
-            m_phy->CalculateTxDuration (cts.GetSerializedSize (), txVector, m_phy->GetFrequency ()) +
+            m_phy->CalculateTxDuration (cts.GetSerializedSize (), txVector, m_phy->GetPhyBand ()) +
             Time (2 * GetSifs ()) + Time (2 * GetSlotTime ()) +
             m_phy->CalculatePhyPreambleAndHeaderDuration (txVector);
           m_navCounterResetCtsMissed = Simulator::Schedule (navCounterResetCtsMissedDelay,
@@ -1696,7 +1609,7 @@
 
   if (hdr.IsCfPoll () && m_stationManager->GetPcfSupported ())
     {
-      Simulator::Schedule (GetPifs () + m_phy->CalculateTxDuration (psdu->GetSize (), txVector, m_phy->GetFrequency ()), &MacLow::CfPollTimeout, this);
+      Simulator::Schedule (GetPifs () + m_phy->CalculateTxDuration (psdu->GetSize (), txVector, m_phy->GetPhyBand ()), &MacLow::CfPollTimeout, this);
     }
   if (hdr.IsBeacon () && m_stationManager->GetPcfSupported ())
     {
@@ -1827,17 +1740,17 @@
   duration += GetCtsDuration (m_currentPacket->GetAddr1 (), rtsTxVector);
   duration += GetSifs ();
   duration += m_phy->CalculateTxDuration (m_currentPacket->GetSize (),
-                                          m_currentTxVector, m_phy->GetFrequency ());
+                                          m_currentTxVector, m_phy->GetPhyBand ());
   duration += GetResponseDuration (m_txParams, m_currentTxVector, m_currentPacket->GetAddr1 ());
   if (m_txParams.HasNextPacket ())
     {
       duration += m_phy->CalculateTxDuration (m_txParams.GetNextPacketSize (),
-                                              m_currentTxVector, m_phy->GetFrequency ());
+                                              m_currentTxVector, m_phy->GetPhyBand ());
       duration += GetResponseDuration (m_txParams, m_currentTxVector, m_currentPacket->GetAddr1 ());
     }
   rts.SetDuration (duration);
 
-  Time txDuration = m_phy->CalculateTxDuration (GetRtsSize (), rtsTxVector, m_phy->GetFrequency ());
+  Time txDuration = m_phy->CalculateTxDuration (GetRtsSize (), rtsTxVector, m_phy->GetPhyBand ());
   // After transmitting an RTS frame, the STA shall wait for a CTSTimeout interval with
   // a value of aSIFSTime + aSlotTime + aRxPHYStartDelay (IEEE 802.11-2016 sec. 10.3.2.7).
   // aRxPHYStartDelay equals the time to transmit the PHY header.
@@ -1853,7 +1766,7 @@
 void
 MacLow::StartDataTxTimers (WifiTxVector dataTxVector)
 {
-  Time txDuration = m_phy->CalculateTxDuration (m_currentPacket->GetSize (), dataTxVector, m_phy->GetFrequency ());
+  Time txDuration = m_phy->CalculateTxDuration (m_currentPacket->GetSize (), dataTxVector, m_phy->GetPhyBand ());
   if (m_txParams.MustWaitNormalAck () && !IsCfPeriod ())
     {
       // the timeout duration is "aSIFSTime + aSlotTime + aRxPHYStartDelay, starting
@@ -1883,29 +1796,13 @@
   else if (m_txParams.HasNextPacket ())
     {
       NS_ASSERT (m_waitIfsEvent.IsExpired ());
-      Time delay = txDuration;
-      if (m_stationManager->GetRifsPermitted ())
-        {
-          delay += GetRifs ();
-        }
-      else
-        {
-          delay += GetSifs ();
-        }
+      Time delay = txDuration + GetSifs ();
       m_waitIfsEvent = Simulator::Schedule (delay, &MacLow::WaitIfsAfterEndTxFragment, this);
     }
   else if (m_currentPacket->GetHeader (0).IsQosData () && m_currentTxop->IsQosTxop () &&
            m_currentTxop->GetTxopLimit ().IsStrictlyPositive () && m_currentTxop->GetTxopRemaining () > GetSifs ())
    {
-      Time delay = txDuration;
-      if (m_stationManager->GetRifsPermitted ())
-        {
-          delay += GetRifs ();
-        }
-      else
-        {
-          delay += GetSifs ();
-        }
+      Time delay = txDuration + GetSifs ();
       m_waitIfsEvent = Simulator::Schedule (delay, &MacLow::WaitIfsAfterEndTxPacket, this);
     }
   else
@@ -1927,16 +1824,9 @@
       Time duration = GetResponseDuration (m_txParams, m_currentTxVector, m_currentPacket->GetAddr1 ());
       if (m_txParams.HasNextPacket ())
         {
-          if (m_stationManager->GetRifsPermitted ())
-            {
-              duration += GetRifs ();
-            }
-          else
-            {
-              duration += GetSifs ();
-            }
+          duration += GetSifs ();
           duration += m_phy->CalculateTxDuration (m_txParams.GetNextPacketSize (),
-                                                  m_currentTxVector, m_phy->GetFrequency ());
+                                                  m_currentTxVector, m_phy->GetPhyBand ());
           duration += GetResponseDuration (m_txParams, m_currentTxVector, m_currentPacket->GetAddr1 ());
         }
       m_currentPacket->SetDuration (duration);
@@ -2027,13 +1917,13 @@
 
   duration += GetSifs ();
   duration += m_phy->CalculateTxDuration (m_currentPacket->GetSize (),
-                                          m_currentTxVector, m_phy->GetFrequency ());
+                                          m_currentTxVector, m_phy->GetPhyBand ());
   duration += GetResponseDuration (m_txParams, m_currentTxVector, m_currentPacket->GetAddr1 ());
   if (m_txParams.HasNextPacket ())
     {
       duration += GetSifs ();
       duration += m_phy->CalculateTxDuration (m_txParams.GetNextPacketSize (),
-                                              m_currentTxVector, m_phy->GetFrequency ());
+                                              m_currentTxVector, m_phy->GetPhyBand ());
       duration += GetResponseDuration (m_txParams, m_currentTxVector, m_currentPacket->GetAddr1 ());
     }
 
@@ -2041,7 +1931,7 @@
 
   ForwardDown (Create<const WifiPsdu> (Create<Packet> (), cts), ctsTxVector);
 
-  Time txDuration = m_phy->CalculateTxDuration (GetCtsSize (), ctsTxVector, m_phy->GetFrequency ());
+  Time txDuration = m_phy->CalculateTxDuration (GetCtsSize (), ctsTxVector, m_phy->GetPhyBand ());
   txDuration += GetSifs ();
   NS_ASSERT (m_sendDataEvent.IsExpired ());
 
@@ -2093,19 +1983,12 @@
   Time newDuration = GetResponseDuration (m_txParams, m_currentTxVector, m_currentPacket->GetAddr1 ());
   if (m_txParams.HasNextPacket ())
     {
-      if (m_stationManager->GetRifsPermitted ())
-        {
-          newDuration += GetRifs ();
-        }
-      else
-        {
-          newDuration += GetSifs ();
-        }
-      newDuration += m_phy->CalculateTxDuration (m_txParams.GetNextPacketSize (), m_currentTxVector, m_phy->GetFrequency ());
+      newDuration += GetSifs ();
+      newDuration += m_phy->CalculateTxDuration (m_txParams.GetNextPacketSize (), m_currentTxVector, m_phy->GetPhyBand ());
       newDuration += GetResponseDuration (m_txParams, m_currentTxVector, m_currentPacket->GetAddr1 ());
     }
 
-  Time txDuration = m_phy->CalculateTxDuration (m_currentPacket->GetSize (), m_currentTxVector, m_phy->GetFrequency ());
+  Time txDuration = m_phy->CalculateTxDuration (m_currentPacket->GetSize (), m_currentTxVector, m_phy->GetPhyBand ());
   duration -= txDuration;
   duration -= GetSifs ();
 
@@ -2584,9 +2467,14 @@
 {
   NS_LOG_FUNCTION (this);
   bool normalAck = false;
-  bool ampduSubframe = false; //flag indicating the packet belongs to an A-MPDU and is not a VHT/HE single MPDU
-  if (txVector.IsAggregation ())
+  bool ampduSubframe = txVector.IsAggregation (); //flag indicating the packet belongs to an A-MPDU and is not a VHT/HE single MPDU
+  //statusPerMpdu is empty for intermediate MPDU forwarding.
+  //This function is called also once the PPDU has been fully received by the PHY,
+  //in that case statusPerMpdu carries the information about the received MPDUs.
+  if (ampduSubframe && !statusPerMpdu.empty ())
     {
+      //We are here if a S-MPDU is received or if all MPDUs of an A-MPDU have been
+      //received (but have been already forwarded up, so ReceiveOk won't be called)
       NS_ASSERT (psdu->IsAggregate ());
       ampduSubframe = true;
       auto n = psdu->begin ();
@@ -2594,9 +2482,6 @@
       NS_ABORT_MSG_IF (psdu->GetNMpdus () != statusPerMpdu.size (), "Should have one receive status per MPDU");
 
       WifiMacHeader firsthdr = (*n)->GetHeader ();
-      NS_LOG_DEBUG ("duration/id=" << firsthdr.GetDuration ());
-      NotifyNav ((*n)->GetPacket (), firsthdr);
-
       if (firsthdr.GetAddr1 () == m_self)
         {
           //Iterate over all MPDUs and notify reception only if status OK
@@ -2629,7 +2514,10 @@
                   else if (firsthdr.IsData () || firsthdr.IsQosData ())
                     {
                       NS_LOG_DEBUG ("Deaggregate packet from " << firsthdr.GetAddr2 () << " with sequence=" << firsthdr.GetSequenceNumber ());
-                      ReceiveOk ((*n), rxSnr, txVector, ampduSubframe);
+                      if (psdu->IsSingle ())
+                        {
+                          ReceiveOk ((*n), rxSnr, txVector, ampduSubframe);
+                        }
                       if (firsthdr.IsQosAck ())
                         {
                           NS_LOG_DEBUG ("Normal Ack");
@@ -2671,7 +2559,7 @@
     }
   else
     {
-      /* Simple MPDU */
+      /* An MPDU has been received */
       NS_ASSERT (!psdu->IsAggregate ());
       ReceiveOk ((*psdu->begin ()), rxSnr, txVector, ampduSubframe);
     }
@@ -2705,7 +2593,7 @@
   hdr.SetType (WIFI_MAC_DATA);
   WifiMacTrailer fcs;
   uint32_t maxMacFrameSize = MAX_MSDU_SIZE + hdr.GetSerializedSize () + fcs.GetSerializedSize ();
-  Time nextTransmission = 2 * m_phy->CalculateTxDuration (maxMacFrameSize, m_currentTxVector, m_phy->GetFrequency ()) + 3 * GetSifs () + m_phy->CalculateTxDuration (GetCfEndSize (), m_currentTxVector, m_phy->GetFrequency ());
+  Time nextTransmission = 2 * m_phy->CalculateTxDuration (maxMacFrameSize, m_currentTxVector, m_phy->GetPhyBand ()) + 3 * GetSifs () + m_phy->CalculateTxDuration (GetCfEndSize (), m_currentTxVector, m_phy->GetPhyBand ());
   return ((GetRemainingCfpDuration () - nextTransmission).IsPositive ());
 }
 
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/wifi/model/mac-low.h ns-3.32/src/wifi/model/mac-low.h
--- ns-3.31/src/wifi/model/mac-low.h	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/wifi/model/mac-low.h	2020-10-06 15:35:43.000000000 -0700
@@ -112,54 +112,12 @@
    */
   void SetAddress (Mac48Address ad);
   /**
-   * Set Ack timeout of this MacLow.
-   *
-   * \param ackTimeout Ack timeout of this MacLow
-   */
-  void SetAckTimeout (Time ackTimeout);
-  /**
-   * Set Basic BlockAck timeout of this MacLow.
-   *
-   * \param blockAckTimeout Basic BlockAck timeout of this MacLow
-   */
-  void SetBasicBlockAckTimeout (Time blockAckTimeout);
-  /**
-   * Set Compressed BlockAck timeout of this MacLow.
-   *
-   * \param blockAckTimeout Compressed BlockAck timeout of this MacLow
-   */
-  void SetCompressedBlockAckTimeout (Time blockAckTimeout);
-  /**
    * Enable or disable CTS-to-self capability.
    *
    * \param enable Enable or disable CTS-to-self capability
    */
   void SetCtsToSelfSupported (bool enable);
   /**
-   * Set Short Interframe Space (SIFS) of this MacLow.
-   *
-   * \param sifs SIFS of this MacLow
-   */
-  void SetSifs (Time sifs);
-  /**
-   * Set Reduced Interframe Space (RIFS) of this MacLow.
-   *
-   * \param rifs RIFS of this MacLow
-   */
-  void SetRifs (Time rifs);
-  /**
-   * Set slot duration of this MacLow.
-   *
-   * \param slotTime slot duration of this MacLow
-   */
-  void SetSlotTime (Time slotTime);
-  /**
-   * Set PCF Interframe Space (PIFS) of this MacLow.
-   *
-   * \param pifs PIFS of this MacLow
-   */
-  void SetPifs (Time pifs);
-  /**
    * \param interval the expected interval between two beacon transmissions.
    */
   void SetBeaconInterval (Time interval);
@@ -190,24 +148,6 @@
    */
   Mac48Address GetAddress (void) const;
   /**
-   * Return Ack timeout of this MacLow.
-   *
-   * \return Ack timeout
-   */
-  Time GetAckTimeout (void) const;
-  /**
-   * Return Basic BlockAck timeout of this MacLow.
-   *
-   * \return Basic BlockAck timeout
-   */
-  Time GetBasicBlockAckTimeout (void) const;
-  /**
-   * Return Compressed BlockAck timeout of this MacLow.
-   *
-   * \return Compressed BlockAck timeout
-   */
-  Time GetCompressedBlockAckTimeout (void) const;
-  /**
    * Return Short Interframe Space (SIFS) of this MacLow.
    *
    * \return SIFS
@@ -226,12 +166,6 @@
    */
   Time GetPifs (void) const;
   /**
-   * Return Reduced Interframe Space (RIFS) of this MacLow.
-   *
-   * \return RIFS
-   */
-  Time GetRifs (void) const;
-  /**
    * \return the expected interval between two beacon transmissions.
    */
   Time GetBeaconInterval (void) const;
@@ -933,13 +867,6 @@
   MacLowTransmissionParameters m_txParams;  //!< Transmission parameters of the current packet
   Mac48Address m_self;                      //!< Address of this MacLow (Mac48Address)
   Mac48Address m_bssid;                     //!< BSSID address (Mac48Address)
-  Time m_ackTimeout;                        //!< Ack timeout duration
-  Time m_basicBlockAckTimeout;              //!< Basic BlockAck timeout duration
-  Time m_compressedBlockAckTimeout;         //!< Compressed BlockAck timeout duration
-  Time m_sifs;                              //!< Short Interframe Space (SIFS) duration
-  Time m_slotTime;                          //!< Slot duration
-  Time m_pifs;                              //!< PCF Interframe Space (PIFS) duration
-  Time m_rifs;                              //!< Reduced Interframe Space (RIFS) duration
 
   Time m_beaconInterval;   //!< Expected interval between two beacon transmissions
   Time m_cfpMaxDuration;   //!< CFP max duration
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/wifi/model/minstrel-ht-wifi-manager.cc ns-3.32/src/wifi/model/minstrel-ht-wifi-manager.cc
--- ns-3.31/src/wifi/model/minstrel-ht-wifi-manager.cc	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/wifi/model/minstrel-ht-wifi-manager.cc	2020-10-06 15:35:43.000000000 -0700
@@ -320,7 +320,7 @@
   txvector.SetMode (mode);
   txvector.SetPreambleType (WIFI_PREAMBLE_HT_MF);
   return WifiPhy::CalculatePhyPreambleAndHeaderDuration (txvector)
-         + WifiPhy::GetPayloadDuration (m_frameLength, txvector, phy->GetFrequency (), mpduType);
+         + WifiPhy::GetPayloadDuration (m_frameLength, txvector, phy->GetPhyBand (), mpduType);
 }
 
 Time
@@ -1517,8 +1517,8 @@
   uint32_t cw = 15;                     // Is an approximation.
   uint32_t cwMax = 1023;
   Time cwTime, txTime, dataTxTime;
-  Time slotTime = GetMac ()->GetSlot ();
-  Time ackTime = GetMac ()->GetBasicBlockAckTimeout ();
+  Time slotTime = GetPhy ()->GetSlot ();
+  Time ackTime = GetPhy ()->GetSifs () + GetPhy ()->GetBlockAckTxTime ();
 
   if (station->m_groupsTable[groupId].m_ratesTable[rateId].ewmaProb < 1)
     {
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/wifi/model/minstrel-wifi-manager.cc ns-3.32/src/wifi/model/minstrel-wifi-manager.cc
--- ns-3.31/src/wifi/model/minstrel-wifi-manager.cc	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/wifi/model/minstrel-wifi-manager.cc	2020-10-06 15:35:43.000000000 -0700
@@ -120,7 +120,7 @@
       WifiTxVector txVector;
       txVector.SetMode (mode);
       txVector.SetPreambleType (WIFI_PREAMBLE_LONG);
-      AddCalcTxTime (mode, phy->CalculateTxDuration (m_pktLen, txVector, phy->GetFrequency ()));
+      AddCalcTxTime (mode, phy->CalculateTxDuration (m_pktLen, txVector, phy->GetPhyBand ()));
     }
   WifiRemoteStationManager::SetupPhy (phy);
 }
@@ -962,17 +962,17 @@
   //See rc80211_minstrel.c
 
   //First transmission (Data + Ack timeout)
-  Time tt = dataTransmissionTime + GetMac ()->GetAckTimeout ();
+  Time tt = dataTransmissionTime + GetPhy ()->GetSifs () + GetPhy ()->GetAckTxTime ();
 
   uint32_t cwMax = 1023;
   uint32_t cw = 31;
   for (uint32_t retry = 0; retry < longRetries; retry++)
     {
       //Add one re-transmission (Data + Ack timeout)
-      tt += dataTransmissionTime + GetMac ()->GetAckTimeout ();
+      tt += dataTransmissionTime + GetPhy ()->GetSifs () + GetPhy ()->GetAckTxTime ();
 
       //Add average back off (half the current contention window)
-      tt += (cw / 2.0) * GetMac ()->GetSlot ();
+      tt += (cw / 2.0) * GetPhy ()->GetSlot ();
 
       //Update contention window
       cw = std::min (cwMax, (cw + 1) * 2);
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/wifi/model/mpdu-aggregator.cc ns-3.32/src/wifi/model/mpdu-aggregator.cc
--- ns-3.31/src/wifi/model/mpdu-aggregator.cc	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/wifi/model/mpdu-aggregator.cc	2020-10-06 15:35:43.000000000 -0700
@@ -213,7 +213,7 @@
   std::vector<Ptr<WifiMacQueueItem>> mpduList;
   Mac48Address recipient = mpdu->GetHeader ().GetAddr1 ();
 
-  NS_ASSERT (mpdu->GetHeader ().IsQosData () && !recipient.IsBroadcast ());
+  NS_ASSERT (mpdu->GetHeader ().IsQosData () && !recipient.IsGroup ());
 
   uint8_t tid = GetTid (mpdu->GetPacket (), mpdu->GetHeader ());
   auto edcaIt = m_edca.find (QosUtilsMapTidToAc (tid));
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/wifi/model/msdu-aggregator.cc ns-3.32/src/wifi/model/msdu-aggregator.cc
--- ns-3.31/src/wifi/model/msdu-aggregator.cc	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/wifi/model/msdu-aggregator.cc	2020-10-06 15:35:43.000000000 -0700
@@ -86,7 +86,7 @@
    * individual address or to the GCR concealment address" (Section 10.12
    * of 802.11-2016)
    */
-  NS_ABORT_MSG_IF (recipient.IsBroadcast (), "Recipient address is broadcast");
+  NS_ABORT_MSG_IF (recipient.IsGroup (), "Recipient address is group addressed");
 
   Ptr<QosTxop> qosTxop = m_edca.find (QosUtilsMapTidToAc (tid))->second;
   Ptr<WifiMacQueue> queue = qosTxop->GetWifiMacQueue ();
